#include <stdio.h>
#include <string.h>

long writeToOutputFile(FILE *pInFile, FILE *pOutFile) {
   long fileSize;
   long lIdx, lLoop;
   char cBuffer[1024];

    //
    // Get the size of the file.
    //
    fseek(pInFile, 0, SEEK_END);
    fileSize = ftell(pInFile);
    fseek(pInFile, 0, SEEK_SET);

    //
    // Round the file size up to the next 1K boundary.
    //
    fileSize = (fileSize + 1023) & ~1023;

	 //
    // Send the actual data in the file.
    //
    for(lIdx = 0; lIdx < fileSize; lIdx += 1024)
    {
        //
        // Read the next 1K block from the file.
        //
        lLoop = fread(cBuffer, 1, 1024, pInFile);

        //
        // If we could not read 1K from the file, then fill the remainder of
        // the buffer with zeros.
        //
        for(; lLoop < 1024; lLoop++)
        {
            cBuffer[lLoop] = 0;
        }

        lLoop = fwrite(cBuffer, 1, 1024, pOutFile);

	}

	return fileSize;
}

int main(int argc, char *argv[])
{

   FILE *pInFile1;
   FILE *pInFile2;
   FILE *pOutFile;
   char outFile[]="rom.bin";
  char cBuffer[1024];
  long writtenFileSize, left;
  int loop, i;


      //
    // Open the file to be downloaded.
    //
    pInFile1 = fopen(argv[1], "rb");
    if(!pInFile1)
    {
        fprintf(stderr, "Could not open file '%s'.\n", argv[1]);
        return(1);
    }

	 pInFile2 = fopen(argv[2], "rb");
    if(!pInFile2)
    {
        fprintf(stderr, "Could not open file '%s'.\n", argv[2]);
        return(1);
    }


	pOutFile = fopen(outFile, "wb");
    if(!pOutFile)
    {
        fprintf(stderr, "Could not create file '%s'.\n", outFile);
        return(1);
    }

    writtenFileSize=writeToOutputFile(pInFile1, pOutFile);

	left=0x400000 - writtenFileSize;
	loop = left/1024;

	//printf("writtenFileSize=0x%x left=0x%x loop=%d \n", writtenFileSize, left, loop);

	for (i=0; i<loop; i++) {

 	  memset(cBuffer, 0, 1024);
      fwrite(cBuffer, 1, 1024, pOutFile);
	}

    writtenFileSize=writeToOutputFile(pInFile2, pOutFile);

    //
    // Close the file.
    //
    fclose(pOutFile);
   fclose(pInFile1);
   fclose(pInFile2);

 
  return 0;

}